# Swift Boilerplate
Clean Architecture for iOS projects (Swift + Programmatically UI + RxSwift + Auto Layout Visual Format + REST + JWT)

## Folder Structure 
```
│   AppDelegate.swift
│   Launcher.swift
│
├───Controllers
│   └───Home
│           HomeController.swift
│           HomeView.swift
│
├───Controls
│       MasterButton.swift
│       MasterLabel.swift
│       MasterScrollView.swift
│       MasterTextField.swift
│
├───Core
│       MasterNavigationController.swift
│       MasterView.swift
│       MasterViewController.swift
│
├───Extensions
│       Dictionary+Extensions.swift
│       Sequence+Extensions.swift
│       String+Extensions.swift
│       UICollectionView+Extensions.swift
│       UITableView+Extensions.swift
│       UIView+Extensions.swift
│
├───Models
│       Todo.swift
│       User.swift
│
├───Resources
│   │   Application+Colors.swift
│   │   Application+Configrations.swift
│   │   Application+Fonts.swift
│   │   Application+Validations.swift
│   │
│   └───Font
│       └───Roboto
│               Roboto-Bold.ttf
│
├───ServerRequests
│       ResponseParser.swift
│       RESTClient.swift
│       RESTUtils.swift
│
├───Services
│       Application.swift
│       MessageManager.swift
│       ReachabilityService.swift
│       UserDefaults.swift
│
└───Utilities
        Events.swift
        Logger.swift
        RxActivity.swift

```
